//
// Title       : Homework 6, problem 2 test fixture
// Author      : Carl Ebeling
// Company     : CSE 370
//
//-------------------------------------------------------------------------------------------------
//
// File        : problem2a_tf.v
//				 Homework #6
// Description : This test fixture generates an interesting input pattern for the test circuit
// 				 and checks that it recognizes 4 consecutive 1's
//
//-------------------------------------------------------------------------------------------------
`timescale 1ns / 1ns


module problem2a_tf (CLK, reset, out, in);

input CLK, reset;
input in;			// Data output to test circuit
output out;			// Data input to test circuit
reg out;

integer count;	    // Count number of tests so we can stop	 
integer errors;		// Count errors
reg [4:0] shift;

initial begin
	count = 0;
	errors = 0;
end

always @(posedge CLK) begin
	#2	// Wait for all registers to give their new values
	// Make sure we've run enough cycles to fill the shift registers
	if ((count > 6) && ((shift[3:0] === 15) !== in)) begin
		$display("***Error**** Output should be:%b but it is:%b", shift===15, in); 
		errors = errors + 1;
		$stop;
	end	
	// The default number of cycles is 100
	if (count > 90) begin
		$display("Test completed with %d errors", errors);
		$finish;			// End the simulation
	end
	count = count + 1;
	#1 out = $random;	// Produce new output for next clock cycle
	shift = { out, shift[4:1] };
end
	
endmodule
